/*
 * Author:      William Chia-Wei Cheng (william@cs.ucla.edu)
 *
 * Copyright (C) 1990-1999, William Chia-Wei Cheng.
 *
 * Permission limited to the use, copy, display, distribute without
 * charging for a fee, and produce derivative works of "tgif" and
 * its documentation for not-for-profit purpose is hereby granted by
 * the Author, provided that the above copyright notice appears in
 * all copies made of "tgif" and that both the copyright notice
 * and this permission notice appear in supporting documentation,
 * and that the name of the Author not be used in advertising or
 * publicity pertaining to distribution of the software without
 * specific, written prior permission.  The Author makes no
 * representations about the suitability of this software for any
 * purpose.  It is provided "as is" without express or implied
 * warranty.  All other rights (including, but not limited to, the
 * right to sell "tgif", the right to sell or distribute derivative
 * works of "tgif", the right to distribute "tgif" for a fee, and
 * the right to include "tgif" or derivative works of "tgif" in a
 * for-sale product) are reserved by the Author.
 *
 * THE AUTHOR DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS,
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, INDIRECT
 * OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
 * LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
 * NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN
 * CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * @(#)$Header: /mm/src/tgif/v4/RCS/wb.e,v 4.4 1999/01/07 16:18:06 william Exp $
 */

#ifndef _WB_E_
#define _WB_E_

typedef struct WhiteBoardRec {
   int	do_whiteboard;
   int	first_redo_after_deserialize;

   int	port; /* 8009 */

   char	send_fname[MAXPATHLENGTH];
   FILE *send_fp;
   int	send_socket;

   int	listening;

   char	listen_fname[MAXPATHLENGTH];
   FILE	*listen_fp;
   int	listen_socket;

   struct CmdRec *first_cmd, *last_cmd, *cur_cmd;
   struct CmdRec *first_stopped_cmd; /* don't know how to use this yet! */
} *WhiteBoardPtr;

extern struct WhiteBoardRec	gstWBInfo;

extern int	cmdLineNoWhiteBoard;
extern int	cmdLineWhiteBoardListenOnly;

#ifdef _INCLUDE_FROM_WB_C_
#undef extern
#define extern
#endif /*_INCLUDE_FROM_WB_C_*/

/* =================== Remote Related Functions =================== */

#ifdef _TGIF_WB2

#ifdef _TGIF_DBG_WB2
extern int	AcceptWBSocket ARGS_DECL((void));
#endif /* _TGIF_DBG_WB2 */

extern int	SendWBData ARGS_DECL((char *pszWBData));

#endif /* _TGIF_WB2 */

/* =================== Cmd Related Functions =================== */

extern char	* SerializeCmd ARGS_DECL((int CmdType, struct SubCmdRec *,
                                     struct SelRec *Top, struct SelRec *Bot,
                                     int NumObjs));
extern void	SerializeFreeBuf ARGS_DECL((char *psz_buf));

extern int	ReadCmd ARGS_DECL((FILE *FP, char *Inbuf));
extern int	ReadBeforeImage ARGS_DECL((FILE *FP, char *Inbuf));
extern int	ReadAfterPositions ARGS_DECL((FILE *FP, char *Inbuf));
extern int	ReadAfterImage ARGS_DECL((FILE *FP, char *Inbuf));
extern void	ProcessRemoteCmd ARGS_DECL((char *psz_buf, int buf_sz));

/* =================== Init and CleanUp Functions =================== */

extern void	CleanUpWhiteBoard ARGS_DECL((void));
extern int	InitWhiteBoard ARGS_DECL((void));

#ifdef _INCLUDE_FROM_WB_C_
#undef extern
#ifndef _NO_RECURSIVE_EXTERN
#define extern extern
#endif /* ~_NO_RECURSIVE_EXTERN */
#endif /*_INCLUDE_FROM_WB_C_*/

#endif /*_WB_E_*/
